unit UReader;
{*
 simple exemple pour partager une structure type record entre plusieurs process
 Y.Lafargue  contact@ly-asds.com 
*}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

Type
  tag_TrfData = record
    lpdata   : array[0..255] of char;
    cbInQue  : DWORD;
    cbOutQue : DWORD;
  end;
  TTrfData = tag_TrfData;
  PTrfData = ^TTrfData;

Type
  TCFileMapping = class(TObject)
   private
    hFileMape                   : Thandle;
    lpMapAddress                : pointer;
    TrfData                     : PTrfData;
    FFileMapResult              : String;
   protected
    property    FileMapResult   : String read FFileMapResult;
   public
    constructor Create;
    destructor  destroy; override;
    function    Close           : boolean;
    function    OpenR           : boolean;
    function    Read            : boolean;
   end;


type
  TForm1 = class(TForm)
    Button1: TButton;
    Button3: TButton;
    Button4: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1        : TForm1;
  CFileMapping : TCFileMapping = nil;

implementation

{$R *.DFM}



{******************************************************************************}
{*                                TFileMapping                                *}
{******************************************************************************}


{*----------------------------------------------------------------------------*}
constructor TCFilemapping.Create;
begin
 Inherited Create;
 hFileMape    := 0;
 lpMapAddress := nil;
 Getmem(TrfData,sizeof(TTrfData));
end;



{*----------------------------------------------------------------------------*}
destructor TCFileMapping.destroy;
begin
 if Assigned(TrfData) then Freemem(TrfData);
 Inherited destroy;
end;



{*----------------------------------------------------------------------------*}
function TCFilemapping.OpenR : boolean;
begin

 Result := false;

 if hFileMape <> 0 then begin
   FFileMapResult := ' "FileMapping" already open ! ';
   exit;
 end;

 hFileMape := OpenFileMapping(FILE_MAP_READ,  {correction pour XP}
                              false,
                              pchar('MyLYWriterReaderMapping')
                              );

 If hFileMape = 0 then
   FFileMapResult := ' "FileMapping" opening in "reading mode".... raised ! '
 Else begin
   FFileMapResult := ' "FileMapping" open ';

   lpMapAddress := MapViewOfFile(hFileMape,
                                 FILE_MAP_READ,
                                 0,
                                 0,
                                 0);

   If lpMapAddress = nil then
     FFileMapResult := FFileMapResult + ' Error in allocating of "FileMapping" '
   Else begin
    Result := true;
    FFileMapResult := FFileMapResult + ' "FileMapped" allocated ';
   End;
 End;

end;



{*----------------------------------------------------------------------------*}
Function TCFilemapping.Close : boolean;
begin

 Result:=True;

 If hFileMape <> 0 then begin
   If lpMapAddress <> nil then begin
     If not UnMapViewOfFile(lpMapAddress) then begin
       FFileMapResult := ' Error in deallocating of "FileMapping" ';
       Result := false;
       exit;
     End;
   End;
   lpMapAddress:=nil;
   If not CloseHandle(hFileMape) then begin
     FFileMapResult := ' Error in closing of "FileMapping" ';
     Result := false;
     exit;
   End;
   hFileMape := 0;
   FFileMapResult := ' "FileMapping" Closed ';
 End;

end;



{*----------------------------------------------------------------------------*}
function TCFilemapping.Read : boolean;
var
   TempText : string;

begin

 Result:=true;

 If (hFileMape = 0) or (lpMapAddress = nil) or (TrfData = nil)
  then begin
    FFileMapResult :='';
    if hFileMape = 0 then FFileMapResult := FFileMapResult + ' "FileMapping" not open ';
    if lpMapAddress = nil then FFileMapResult := FFileMapResult + ' "FileMapping" not allocated ';
    if TrfData = nil then FFileMapResult := FFileMapResult + ' No strucure ready ';
    Result := false;
    exit;
  End;

 CopyMemory(TrfData,lpMapAddress,sizeof(TTrfData));

 TempText := strpas(TrfData^.lpdata);
 Setlength(TempText,TrfData^.cbOutQue);

 FFileMapResult := ' data read : ' + TempText + #13#10 +
                   ' cboutQue =  ' + inttostr(TrfData^.cbOutQue) + #13#10 +
                   ' cbInQue  =  ' + inttostr(TrfData^.cbInQue);

end;




{******************************************************************************}
{*                                   TForm                                    *}
{******************************************************************************}


{*----------------------------------------------------------------------------*}
procedure TForm1.Button1Click(Sender: TObject);
begin

 if Assigned(CFileMapping)
  then begin
   CFileMapping.OpenR;
   memo1.lines.add(CFileMapping.FileMapResult);
  end;

end;


{*----------------------------------------------------------------------------*}
procedure TForm1.Button4Click(Sender: TObject);
begin

  if Assigned(CFileMapping) then begin
   CFIleMapping.Read;
   memo1.lines.add(CFIleMapping.FileMapResult);
  end;

end;



{*----------------------------------------------------------------------------*}
procedure TForm1.Button3Click(Sender: TObject);
begin

 if Assigned(CFileMapping) then begin
  CFIleMapping.close;
  memo1.lines.add(CFIleMapping.FileMapResult);
 end;

end;



{*----------------------------------------------------------------------------*}
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin

 Canclose := True;
 if Assigned(CFileMapping) then
  if not CFIleMapping.Close then begin
   memo1.lines.add(CFIleMapping.FileMapResult);
   CanClose := false;
  end;

end;



{*----------------------------------------------------------------------------*}
procedure TForm1.FormCreate(Sender: TObject);
begin
 CFIleMapping := TCFIleMapping.create;
end;



{*----------------------------------------------------------------------------*}
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 CFileMapping.Free;
end;


end.
